#!/usr/bin/python   
#-*-coding:utf8-*-

import os 
import datetime
import message_all

'''
Load Average 就是一段时间 (1 分钟、5分钟、15分钟) 内平均 Load 。
'''
def load_stat(): 
    loadavg = {} 
    f = open("/proc/loadavg") 
    con = f.read().split() 
    f.close() 
    loadavg['lavg_1']=con[0] 
    loadavg['lavg_5']=con[1] 
    loadavg['lavg_15']=con[2] 
    loadavg['nr']=con[3] 
    loadavg['last_pid']=con[4] 
    #print "loadavg (5m):",loadavg['lavg_5']
    return loadavg 
#print loadavg_15m

def meminfo():
    mem_dic = {} 
    with open('/proc/meminfo') as f:
        for line in f:
            line=line.split(":")
            if 'MemTotal' in line:
                total_m=line[1].split()[0]
                total_m=int(total_m)/1024
                mem_dic['Total_m']=total_m
            elif 'MemFree' in line:
                free_m=line[1].split()[0]
                free_m=int(free_m)/1024
                mem_dic['Free_m']=(free_m)
            elif 'MemAvailable' in line:
                available_m=line[1].split()[0]
                available_m=int(available_m)/1024
                mem_dic['Available_m']=(available_m)
            elif 'Buffers' in line:
                buffers_m=line[1].split()[0]
                buffers_m=int(buffers_m)/1024
                mem_dic['Buffers_m']=(buffers_m)
            else:
                pass
    return mem_dic


def disk_check():  
    subject = {}  
    result = os.popen('df -HT').read()
    content = result  
    result = result.split('\n')  
    for line in result:  
        if 'G ' in line or 'M ' in line:  
            line = line.split()  
            for i in line:  
                if '%' in i and int(i.strip('%')) > 85:  ##修改磁盘空间的使用百分比阈值
                    subject[line[-1]]=i
    return subject
# 获取ip
def get_ip():
    #cmd_get_ip = "/sbin/ifconfig |grep 'inet addr'|awk -F\: '{print $2}'|awk '{print $1}' | grep -v '^127' | grep -v '192'"
#    cmd_get_ip = "ifconfig |grep 'inet addr'|awk -F\: '{print $2}'|awk '{print $1}' | grep -v '^127'"
    cmd_get_ip = "/sbin/ifconfig |grep 'inet 192'|awk -F ' ' '{print $2}'|awk '{print $1}' |grep -v '1$'"
    get_ip_info = os.popen(cmd_get_ip).readline().strip()
    return get_ip_info
 
if __name__=='__main__':
    now = datetime.datetime.now()
    ip=get_ip()
    print ip,now

    Tg_5m=load_stat()['lavg_5'].split('.')[0]
    Tm=meminfo()['Total_m']
    Fm=meminfo()['Free_m']
    Bm=meminfo()['Buffers_m']
    Am=meminfo()['Available_m']
    Df=disk_check()

   ###磁盘分区使用率高于阈值；Tg_5 负载高于、等于1； 空闲内存少于200M 告警

#    if len(Df) >= 2 or int(Tg_5m) >=1 or int(Fm) <=200:
#        print ip,Df,Tg_5m,Fm,'need check....',now.strftime('%Y-%m-%d %H:%M:%S')
#        message_all.mailTo("ops_monitor",["258102866@qq.com","gaofeng@starmerx.com"],'服务器性能指标监控','Ip %s --Load5分钟负载  %s;   磁盘空间使用率 %s;  空闲内存 %sM' %(ip,Tg_5m,Df,Fm))
    if len(Df) >= 1:
        print 'Disk check....[Warning]:',disk_check()
        Df=str(Df)
        message_all.mailTo("ops_monitor",["yangjuan@starmerx.com","wangqiang@starmerx.com","suizhanjun@starmerx.com","luanxiaojian@starmerx.com"],'ebay的listing,谷歌翻译--姜才服务器磁盘指标监控','ebay的listing,谷歌翻译--姜才服务器 54.196.103.47 %s --磁盘空间使用率 %s(大于>80请关注) ' %(ip,Df))
    elif int(Tg_5m) >=10:
        print Tg_5m
        message_all.mailTo("ops_monitor",["yangjuan@starmerx.com","wangqiang@starmerx.com","suizhanjun@starmerx.com","luanxiaojian@starmerx.com"],'ebay的listing,谷歌翻译--姜才服务器性能指标监控','ebay的listing,谷歌翻译--姜才服务器 54.196.103.47 %s --Load(5分钟负载): %s (如>8请关注) ' %(ip,Tg_5m))
    elif int(Am) <=100:
        print ip,"Total memory:",Tm,'M  ',"Free memory:",Fm,'M  ',"Available memory:",Am,'M'
        message_all.mailTo("ops_monitor",["yangjuan@starmerx.com","wangqiang@starmerx.com","suizhanjun@starmerx.com","luanxiaojian@starmerx.com"],'ebay的listing,谷歌翻译--姜才服务器性能指标监控','ebay的listing,谷歌翻译--姜才服务器 54.196.103.47 %s --Available 内存 %sM(小于100M请关注) ' %(ip,Am))
    else:
        print 'all is ok !' ,Df,Tg_5m,Am
